{Tento program sluzi na prenos textovej obrazovky do suboru, verzia 2.0 obsahuje aj ukoncenie cinnosti pomocou INT 2FH}
{Program je shareware, pricom uzivatel ak sa rozhodne program pouzivat je povinny zaplatit registracny poplatok 2 USD}
{Lubovolna cast tohoto pragramu nesmie byt bez suhlasu autora modifikovana, alebo publikovana v akejkolvek podobe.}
{Registrovani uzivatelia obdrzia v najblizsej dobe kompletne zdrojove texty z moznostou exportu do PCX a program pre snimanie}
{obrazovky v grafickych rezimoch VGA a SVGA}
{***********************************************************************************************************************}
{Autor: Eduard Jadron VSDS Zilina KETE, Jilemnickeho 37/46, 036 01 Martin tel/fax/modem/voice +421-842-243810 V.42bis,  }
{***********************************************************************************************************************}
{Tento rezidentny skelet programu urceny na vseobecne pouzitie je odladeny za pomoci Turbo Debugger 4.0 for DOS}
{na pocitaci PENTIUM 100 32Mb RAM, MSDOS 5.0, QEMM 8.0, 1.60 GB HDD.}

program TXTDUMP2; {Verzia: v2.0 s moznostou odinstalovania}

{$M $0400,$0100,$0100}  {Definujem pomocou direktivy $M dostatok pamati pre zasobnik programu, menej sa uz neda poskytnut ...}

{$N+,A+,G+,E-,S-,R-,V-,B-,D+,L+,X-,T-,P-,C-,O-} {Na zmensenie velkosti programu je dobre vypnut vklad. lad. inf. v prog. D-}

Uses Dos,Crt,Utility;

{$F+}

const Idendifikacia     : string = 'Moj_skeletik';

type  StrPtr = ^string;

var   Old_Int_05h       : procedure;                 {Povodny vektor prerusenia}
      Old_Int_08h       : procedure;                 {Povodny vektor prerusenia}
      Old_Int_09h       : procedure;                 {Povodny vektor prerusenia}
      Old_Int_28h       : procedure;                 {Povodny vektor prerusenia}
      Old_Int_2Fh       : procedure;                 {Povodny vektor prerusenia}
      Old_Int_4Ah       : procedure;                 {Povodny vektor prerusenia}
      R                 : registers;                 {Definicia premennej typu register}
      Priznak           : boolean;                   {Poziadavka na aktivaciu}
      Priznak_Scroll    : boolean;
      Aktivita          : boolean;                   {Som aktivny}
      Aktivita_Scroll   : boolean;
      Dos_Busy          : ^byte;                     {Byte adresy, kde je priznak vnorenia DOSu >>> Dos_Busy_Flag}
      ID                : word;                      {Idendifikacia mojho procesu na int2fh}
      ID_Procesu        : word;                      {Cislo procesu}
      Moj_PSP           : word;                      {Adresa PSP}
      Moj_SS,Moj_SP     : word;                      {Zasobnik mojho procesu}
      Old_SS,Old_SP     : word;                      {Zasobnik preruseneho procesu}
      Pocet_Stlpcov     : byte;                      {Pocet stlpcov textoveho rezimu obrazovky}
      Cislo_Stranky     : byte;                      {Cislo videostranky}
      Cislo_rezimu      : byte;                      {Premenna udavajuca cislo rezimu zobrazenia}
      Kurzor_Stlpec     : byte;                      {Premenna uchvavajuca polohu kurzoru}
      Kurzor_Riadok     : byte;                      {Premenna uchvavajuca polohu kurzoru}
      f                 : text;                      {Premenna typu subor pre ulozenie na disk}
      Cislo             : byte;                      {Poradove cislo zosnimaneho programu}
      Scroll            : byte absolute $0000:$0417;
      Citac             : byte;

const Zapni_Scroll      : byte = 16;
      Vypni_Scroll      : byte = 239;

function Odinstaluj: Boolean; far; forward;

procedure Aktualna_Stranka; assembler;
asm
   mov ah,0fh                           {funkcia na zistenie rezimu TXT modu}
   int 10h                              {AL aktual. rezim}
   mov byte ptr es:[Cislo_Stranky],bh   {BH cislo aktualnej stranky}
   mov byte ptr es:[Pocet_Stlpcov],ah   {AH pocet znakov na riadok}
   mov byte ptr es:[Cislo_Rezimu],al    {Do premennej ulozi mod rezimu zobrazenia}
end;

function Citaj_Znak:byte;
var Pomocna : byte;
begin
     asm
        mov ah,08h                      {Citaj znak a jeho atribut}
        mov bh,Cislo_Stranky            {Do BH cislo videostranky, skus nahradit za mov bh,byte ptr es:[Cislo_Stranky]}
        int 10h                         {v AH atributy znaku, farba}
        mov byte ptr ss:[Pomocna],al    {v AL ASCII znak}
     end;
     Citaj_Znak:=Pomocna;
end;

procedure Zisti_Kurzor; assembler;
asm
   mov ah,03h                           {funkcia na zistenie polohy a typu kurzora}
   mov bh,Cislo_Stranky                 {v pozadovanej stranky vo VIDEORAM}
   int 10h                              {vyvolam prerusenie}
   mov byte ptr es:[Kurzor_Stlpec],dl   {obsahy prenesiem do premennych}
   mov byte ptr es:[Kurzor_Riadok],dh   {obsahy prenesiem do premennych}
end;

procedure Pozicia_Kurzoru(Stlpec,Riadok:byte); assembler;
asm
   mov ah,02h                           {funkcia zabezpecujuca presunutie kurzora}
   mov bh,Cislo_Stranky                 {este potrebujem cislo stranky VIDEORAM}
   mov dh,byte ptr ss:[Riadok]          {Riadok obrazovky}
   mov dl,byte ptr ss:[Stlpec]          {Stlpec obrazovky}
   int 10h                              {Vyvolam prerusenie a vykonam co som mal}
end;

procedure Vrat_Kurzor;
begin
   Pozicia_Kurzoru(Kurzor_Stlpec,Kurzor_Riadok); {Procedura zaisti korektny navrat kurzora}
end;

procedure Beep(Vyska,Dlzka:word;Pocet:byte); far;
var i  : byte;
begin
     i:=$00;
     repeat
           Sound(Vyska);
           Delay(Dlzka);
           NoSound;
           Delay(Trunc(Dlzka/2));
           Inc(i,$01);
     until i=Pocet;
end;

procedure Kopiruj_Obrazovku;
var   Retazec   : string[80];           {Premenna obsahujuca riadok obrazovky}
      Meno      : string[12];           {Meno subor do ktoreho zapseme obsah obrazovky}
      x,y       : byte;                 {Suradnice obrazovky 80*25}
const Pripona   : string[4] = '.txt';   {Pripona snimaneho suboru}
begin
     Str(Cislo,Meno);                   {Meno suboru bude poradove cislo}
     Aktivita:=True;                    {Kedze pracujem rezidentne musim nastavit semafor aktivity}
     Assign(f,Meno+Pripona);            {Premennej f priradim }
     Zisti_Kurzor;                      {Pred zapisom ulozim polohu kurzora}
     Retazec:='';                       {Nulujem premennu retazec}
     ReWrite(f);                        {Zalozim novy subor a existujuci prepisem ak by bol}
     Aktualna_Stranka;                  {Zistim aktualnu stranku textoveho rezimu}
     Zisti_Kurzor;                      {Zistim polohu kurzoru na obrazovke}
     for y:=$00 to 24 do                {Je 24 riadkov, preto je ten cyklu snimania po  znakoch}
         begin
              for x:=$00 to (Pocet_Stlpcov-$01) do       {Je 80 stlpcov}
                  begin
                       Pozicia_Kurzoru(x,y);             {Ak chcem citat, potom musim menit polohu kurzoru a citat}
                       Retazec:=Retazec+Chr(Citaj_Znak); {Ukladam to do premennej Retazec ako "pole" 1 riadku}
                  end;
                  WriteLn(f,Retazec);                    {Zapisam na disk}
                  Retazec:='';                           {Nulujem premennu retazec}
         end;
     Close(f);          {Zatvorim otvoreny subor}
     Vrat_Kurzor;       {Obnivim polohu kurzoru pred zacatim snimania obsahu obrazovky}
     Beep(1000,200,1);  {Zvukove znamenie}
     Inc(Cislo,$01);    {Poradove cislo suboru}
     Priznak:=False;    {Zrusim priznak poziadavky aktivity na stlacenie PRINTSCREEN}
     Aktivita:=False;   {Uz nie som aktivny}
end;

procedure Nastav_Scroll;
begin
     Aktivita_Scroll:=True;
     if (Scroll and Zapni_Scroll) = 0 then Scroll:=Scroll or Zapni_Scroll else Scroll:=Scroll and Vypni_Scroll;
     Aktivita_Scroll:=False;
     Priznak_Scroll:=True;
end;

procedure Start; far;
begin
     Aktivita:=True;                    {Dostal som sa sem, tak potom som aktivny}
     asm
        mov word ptr ds:[Old_SS],ss     {Do premennej Old_SS vlozim povodnu hodnotu registra SS}
        mov word ptr ds:[Old_SP],sp     {Do premennej Old_SP vlozim povodnu hodnotu registra SP}
        cli                             {Zakazem prerusenie}
        mov ss,word ptr ds:[Moj_SS]     {Do premennej Moj_SS vlozim hodnotu SS mojho programu}
        mov sp,word ptr ds:[Moj_SP]     {Do premennej Moj_SP vlozim hodnotu SP mojho programu}
        sti                             {Operacie zo segmentovymi registrami uz pominuli, preto povolim prerusenie}
     end;
{Tu sa nachadza vykonna cast prerusovacej rutiny, ktora sa aktivuje pri vyvolani prislusneho prerusenia}
{***********************************************************************************************}
        if Cislo_Rezimu in [0..3] then Kopiruj_Obrazovku else Beep(300,300,3);
{***********************************************************************************************}
     asm
        cli                             {Zakazem prerusenie}
        mov ss,word ptr ds:[Old_SS]     {Vratim register SS preruseneho procesu}
        mov sp,word ptr ds:[Old_SP]     {Vratim register SP preruseneho procesu}
        sti                             {Povolim prerusenie, uz pracujem zo starym zasobnikom}
     end;
     Priznak:=False;
     Aktivita:=False;
end;

procedure New_Int_05h(Flags,cs,ip,ax,bx,cx,dx,si,di,ds,es,bp:word); interrupt;
begin
     asm
        pushf
     end;
     Priznak:=True;
     asm
        push ax         {Odkladam register AX na zasobnik}
        mov al,20h      {Do registra AL signal ukoncenia prerusenia EOI}
        out 20h,al      {Vyslem na riadiaci port 8259}
        pop ax          {Obnovim stav registra AX}
     end;
end;

procedure New_Int_08h(Flags,cs,ip,ax,bx,cx,dx,si,di,ds,es,bp:word); interrupt;
begin
     asm
        pushf
     end;
     Old_Int_08h;
     if (Citac > 18) then Citac:=0;
     if (Priznak=True) and (Aktivita=False) and (Dos_Busy^=$00) then Start;
     if (Priznak_Scroll=True) and (Aktivita_Scroll=False) and (Citac=18) then Nastav_Scroll;
     Inc(Citac);
end;

procedure New_Int_09h(Flags,cs,ip,ax,bx,cx,dx,si,di,ds,es,bp:word); interrupt;
begin
     asm
        pushf
     end;
     Old_Int_09h;
     if Port[$60]=$37 then Priznak:=True;       {Cakam na stlacenie klavesy PRINTSCREEN}
end;

procedure New_Int_28h(Flags,cs,ip,ax,bx,cx,dx,si,di,ds,es,bp:word); interrupt;
begin
     asm
        pushf
     end;
     Old_Int_28h;
     if (Priznak=True) and (Aktivita=False) and (Dos_Busy^<>$00) then Start;
end;

procedure New_Int_2Fh(Flags,cs,ip,ax,bx,cx,dx,si,di,ds,es,bp:word); interrupt;
begin
     if (AX and $FF00)=ID then
        begin
             Case (AX and $00FF) of
                  $00:
                  begin
                       AX:=AX or $00FF;       {Kontrolujem pritomnost v pamati}
                       ES:=Seg(Idendifikacia);{Do segmentoveho registra ES segmentovu cast adresy Idendifikacia}
                       BX:=Ofs(Idendifikacia);{Do univerzalneho registra BX offsetovu cast adresy Idendifikacia}
                  end;
                  $FF:
                  begin
                      if (Odinstaluj=False) then AX:=$F0;     {Nemozem odinstalovat}
                  end;
         end;
end
else
    asm
       mov ax,word ptr ds:[Old_Int_2Fh]         {Do AX offset Old_Int_2Fh}
       mov word ptr cs:[@Off],ax                {Obsah presuniem na adresu @Off}
       mov ax,word ptr ds:[Old_Int_2Fh+2]       {Do AX segment Old_Int_2Fh}
       mov word ptr cs:[@Off+2],ax              {Obsah presuniem na adresu @Off+2}
       pop bp                                   {Odlozim obsah BP registra na zsobnik}
       pop es                                   {Odlozim obsah ES registra na zsobnik}
       pop ds                                   {Odlozim obsah DS registra na zsobnik}
       pop di                                   {Odlozim obsah DI registra na zsobnik}
       pop si                                   {Odlozim obsah SI registra na zsobnik}
       pop dx                                   {Odlozim obsah DX registra na zsobnik}
       pop cx                                   {Odlozim obsah CX registra na zsobnik}
       pop bx                                   {Odlozim obsah BX registra na zsobnik}
       pop ax                                   {Odlozim obsah AX registra na zsobnik}
       jmp dword ptr cs:[@Off]                  {Skok na adresu v pamatovych bunkach}
@Off:  dw 0000h                                 {Ulozenie Offsetu povodnej adresy prerusenia INT2fh}
       dw 0000h                                 {Ulozenie Segmentu povodnej adresy prerusenia INT2fh}
    end;                                        {Je to zretazenie s navratom}
end;

procedure New_Int_4Ah(Flags,cs,ip,ax,bx,cx,dx,si,di,ds,es,bp:word); interrupt;
begin
     asm
        pushf             {Register priznakov odkladam na zasobnik u C++ netreba odklad na zasobnik}
     end;
     Old_Int_4Ah;         {Volam povodny vektor prerusenia}
     Priznak:=True;
end;

{$F-}

function Odinstaluj: Boolean;
var Int_05h,Int_08h : pointer;
    Int_09h,Int_28h : pointer;
    Int_2Fh,Int_4Ah : pointer;
begin
     GetVector($05,Int_05h);
     GetVector($08,Int_08h);
     GetVector($09,Int_09h);
     GetVector($28,Int_28h);
     GetVector($2F,Int_2Fh);
     GetVector($4A,Int_4Ah);
  if ((Int_2Fh=Addr(New_Int_2Fh)) and (Int_4Ah=Addr(New_Int_4Ah)) and (Int_08h=Addr(New_Int_08h))
     and (Int_09h=Addr(New_Int_09h)) and (Int_28h=Addr(New_Int_28h)) and (Int_05h=Addr(New_Int_05h))) then
     begin
          SetVector($05,Addr(Old_Int_05h));
          SetVector($08,Addr(Old_Int_08h));
          SetVector($09,Addr(Old_Int_09h));
          SetVector($28,Addr(Old_Int_28h));
	  SetVector($2F,Addr(Old_Int_2Fh));
          SetVector($4A,Addr(Old_Int_4Ah));
	  R.AH:=$49;                              {Uvolni pamat prostredia}
	  R.ES:=Moj_PSP;                          {Adresa segmentu programu}
          MsDos(R);                               {Vyvolam prerusenie INT 21h}
	  Odinstaluj:=True;                       {Program je odinstalovany}
     end
  else
	Odinstaluj:=False;       {Program nemozem odinstalovat, pretoze niekto prebral moje vektory prerusenia}
end;

function Porovnaj_Retazec(s1,s2:StrPtr): boolean; far;
var i,Max : Integer;
begin
  Max:=Length(s1^);
  If Length(s2^) > Length(s1^) then Max:=Length (s2^);
  for i:=1 to Max do
  begin
       If s1^[i] <> s2^[i] then
          begin
	       Porovnaj_Retazec:=False;      {Retazce nie su zhodne}
	       Exit;
	  end;
  end;
               Porovnaj_Retazec:=True;       {Retazce su zhodne}
end;

procedure Uvolni_Pamat; far;
begin
     R.AH:=$49;                 {Funkcia 49h na uvolnenie pamati programu}
     R.ES:=MemW[Moj_PSP:$2C];   {Adresa segmentu prostredia DOSu, pozor tu ma Cap a Kadlec chybu !!!}
     MsDos(R);                  {Vyvolam prerusenie INT 21h}
end;

procedure Zisti_Dos_Busy; far;
var Pomocna_1 : word;
    Pomocna_2 : word;
begin
     asm
        mov ah,34h                      {Zistim adresu aktivity Dos-u Dos_Busy_Flag}
        int 21h                         {Vyvolam prerusenie INT 21h}
        mov word ptr ss:[Pomocna_1],es  {Segmentova cast adresy Dos_Busy_Flag do ES}
        mov word ptr ss:[Pomocna_2],bx  {Offsetova cast adresy Dos_Busy_Flag do BX}
     end;
        Dos_Busy:=Ptr(Pomocna_1,Pomocna_2);{Premenna Dos_Busy sa naplni z adresy Dos_Busy_Flagu -> Segment*10H+Offset}
end;

procedure Zisti_PSP; far;
begin
     asm
        mov ah,62h                      {Zisti adresu PSP}
        int 21h                         {Vyvolam prerusenie DOSu}
        mov word ptr ds:[Moj_PSP],bx    {Adresa PSP do premennej Moj_PSP}
     end;
end;

procedure Instaluj; far;
begin
     Moj_SS:=SSeg;
     Moj_SP:=SPtr;
     GetVector($05,Addr(Old_Int_05h));          {Odlozim staru rutinu prerusenia}
     GetVector($08,Addr(Old_Int_08h));          {Odlozim staru rutinu prerusenia}
     GetVector($09,Addr(Old_Int_09h));          {Odlozim staru rutinu prerusenia}
     GetVector($28,Addr(Old_Int_28h));          {Odlozim staru rutinu prerusenia}
     GetVector($4A,Addr(Old_Int_4Ah));          {Odlozim staru rutinu prerusenia}
     GetVector($2F,Addr(Old_Int_2Fh));          {Odlozim staru rutinu prerusenia}
     SetVector($05,Addr(New_Int_05h));          {Nastavim novu rutinu prerusenia}
     SetVector($08,Addr(New_Int_08h));          {Nastavim novu rutinu prerusenia}
     SetVector($09,Addr(New_Int_09h));          {Nastavim novu rutinu prerusenia}
     SetVector($28,Addr(New_Int_28h));          {Nastavim novu rutinu prerusenia}
     SetVector($4A,Addr(New_Int_4Ah));          {Nastavim novu adresu prerusenia INT XXH}
     SetVector($2F,Addr(New_Int_2Fh));          {Odlozim staru rutinu multiplexneho prerusenia 2Fh}
     Zisti_Dos_Busy;                            {Dos_Busy_Flag vlastne ukazuje uroven vnorenia, ktore prevadza DOS a aktivitu}
     Zisti_PSP;                                 {Zistim aktivnu adresu PSP programu}
     Uvolni_Pamat;                              {Pomocou funkcie 49h pridelim uvolnim potrebne mnozstvo pamati}
end;

procedure Logo(Retazec:string;Farba,Coll:byte);
begin
     TextColor(Farba);                          {Nastavim pozadovanu farbu}
     GotoXY(40-Round(Length(Retazec)/2),Coll);  {Nastavim kurzor tak, aby som retazec napisal doprostred riadku}
     WriteLn(Retazec);                          {Napisem retazec na obrazovku}
     TextColor(White);                          {Vratim bielu farbu}
end;

begin
     ID_Procesu:=$FF;
     ID:=$00;
     while (ID_Procesu > $7F) do
     begin
          R.AH:=ID_Procesu;   {Som pritomny v pamati ?}
          R.AL:=$00;
          Intr($2F,R);
                       if R.AL=$FF then
                          begin
                               if Porovnaj_Retazec(Addr(Idendifikacia),Ptr(R.ES,R.BX)) then
                                  begin
                                       R.AH:=ID_Procesu;        {}
                                       R.AL:=$FF;
                                       Intr($2F,R);
                                            if R.AX=$F0 then
                                               begin
                                                    HighVideo;
                                                    ClrScr;
                                                    WriteLn('Program nemozem odinstalovat, zmenene vektory prerusenia ...');
                                                    Beep(300,300,3);
                                                    LowVideo;
                                                    Halt(0);
                                               end
                                               else
                                               begin
                                                    HighVideo;
                                                    ClrScr;
                                                    WriteLn('Program odinstalovany z pamati ...');
                                                    Beep(1000,100,1);
                                                    LowVideo;
                                                    Scroll:=Scroll and Vypni_Scroll;
                                                    Halt(0);
                                               end;
                                   end;
                          end
                          else
                              if (ID=0) and (R.AL=0) then ID:=(ID_Procesu shl 8);
                              Dec(ID_Procesu);
                          end;
if (ID <> $00) then
   begin
        ClrScr;
        HighVideo;
        Logo('Tento program ulozi obrazovku v TXT rezime klavesou PRINTSCREEN do suboru.',Yellow,1);
        Logo('Autor: Eduard Jadron, Jilemnickeho 37/46, 036 01 Martin, SLOVAKIA',LightGreen,3);
        Logo('Program TXTDUMP2 je shareware, komercne ho mozno vyuzivat za poplatok 2 USD.',LightCyan+Blink,5);
        WriteLn;
        Delay(2000);
        Cislo:=$00;
        Aktivita:=False;
        Priznak:=False;
        Citac:=0;
        Priznak_Scroll:=True;
        Aktivita_Scroll:=False;
        WriteLn('Program sa nainstaloval rezidentne do pamati ...');
        WriteLn;
        WriteLn('Verzia MSDOS ',Lo(DosVersion),'.',Hi(DosVersion));
        Beep(1000,100,1);
        Instaluj;
        Keep(0);
   end
   else
   begin
        WriteLn('Nenasiel som volne ID cislo pre tento program ...');
   end;
end.